//////////////////////////////////////////////////////////////////////////////
//
// ColorRGB.h
//	Defines for the cColorRGB class.
//
//	-	Encapsulates a red-green-blue pixel
//	-	Tabs set to 3 spaces retaining tab character.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __COLORRGB_H__
#define __COLORRGB_H__

#include "inc/system.h"	// Headers for project.
#include "inc/misc.h"

class cColorRGB
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	BYTE m_r,m_g,m_b;		// (red, green, and blue components of color)


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
public:
	// Constructors
	cColorRGB();
	cColorRGB(BYTE r, BYTE g, BYTE b);

	cColorRGB& set(BYTE r, BYTE g, BYTE b);
																
	//cColorRGB& operator<< ( istream& is );	// Set values from a stream.
	bool operator==(cColorRGB& color);	// Check that a color is equivalent.


	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////
	/*inline*/ BYTE r();	// Return red component
	/*inline*/ BYTE g();	// Return green component
	/*inline*/ BYTE b();	// Return blue component


	///////////////////////////////////////////////////////////////////////////
	//	FRIENDS
	///////////////////////////////////////////////////////////////////////////
	// Write values to disk via stream.
	//friend ostream& operator<< ( ostream& os, cColorRGB& myColor );

	// Read values from stream to class.
	//friend istream& operator>> ( istream& is, cColorRGB& myColor );
};

#endif // __COLORRGB_H__
// vi:set ts=3:
