//////////////////////////////////////////////////////////////////////////////
//
// TextureImage.cpp
//	Implementation of the cTextureImage class.
//
//	-	Loads an image file and converts it to an OpenGL texture.
//	-	Support for loading palette files which create additional OpenGL
//		textures, but with different colors (based on remapping information).
//	-	Tabs set to 3 spaces.
//
//////////////////////////////////////////////////////////////////////////////

#include "TextureImage.h"

#define LOAD_1555_NOALPHA(r, g, b) (((r>>3)<<10)|((g>>3)<<5)|((b>>3)))

int cTextureImage::loadPalette(const char *filename) {
	return 0;
}
/*
int cTextureImage::loadPalette(const char *filename) 
{
	//return 0;
	// XXX THIS WORKS
	// create 4 palettes
	//strncpy(filename1, filename, 256);
	//GLuint txr;
	//createOpenGLTexture();createOpenGLTexture();	
	//createOpenGLTexture();createOpenGLTexture();	
	//return 4;
		  
	vector<uint16> palettes;	// holds the palettes
	FILE* file;
	
	GLubyte* img_data_holder;	// holds original image data when we make the copy
	
	BYTE r,g,b;						// to be read from the file
	uint16 t;						// temporary storage (1 pixel)
	GLubyte header[5];			// palette file header
	
	int max_palettes;				// # of palettes
	int max_entries;				// max entries
	int i;							// index to palettes

	// open the file
	file = fopen(filename, "r");
	if (!file) {
		strncpy(filename1, filename, 256);
		return 0;		// error
	}

	// Read in header values.
	fread(header, 5, 1, file);

	// Make sure file opened and is a valid file.
	if(header[0] != 'p'	|| header[1] != 'a'	|| header[2] != 'l')
	{
		// File header not what was expected.
		//throw exception(); // NOT FOR DREAMCAST
		printf(">> ERROR: pallete header not what was expected!\n");
	}

	max_palettes 		= header[3];	// Number of palettes in file.
	max_entries			= header[4];	// Number of entries per palette.

	// Error if invalid # of palettes or # of entries.
   if (max_palettes == 0 || max_entries == 0) {
      //throw exception();
      printf(">> ERROR:  invalid # of palettes or palette entries.\n");
   }
	
	// Loop through each palette, storing it's values.
	for (i = 0; i < max_palettes; i++)
	{
		// Add another palette to the collection.
		palettes.push_back(cColorRGBPalette());

		// Loop through each entry in the palette, reading the red-green-blue
		// values from disk.
		for (int iEntry = 0; iEntry < iMaxEntries; iEntry++) {
			r = fgetc(file); g = fgetc(file); b = fgetc(file);
			t = LOAD_1555_NOALPHA(r,g,b);  // take r,g,b and output them in 2 bytes, no alpha
			vPalettes[iPalette] += t;
		}

	} // END palette loop

	pImageDataHolder = m_pImageData;	// Store original image data location.

}*/

#ifdef GGGGGGGGG
int cTextureImage::loadPalette(const char *filename)
{

	// XXX this code doesnt work right yet
	
	FILE* file;										// Handle to palette file
	vector<cColorRGBPalette>	vPalettes;	// Holds color values.
	
	int iMaxPalettes = 0;					// # of palettes.
	GLubyte*	pImageDataHolder = NULL;	// Holds original image data location.
	
	unsigned short t;							// temporary storage (2 bytes)
	BYTE r,g,b;

	GLubyte		header[5];		// Head of palette file

	// open the file
	file = fopen(filename, "r");
	if (!file) {
		strncpy(filename1, filename, 256);
		return 0;		// error
	}

	// Read in header values.
	fread(header, 5, 1, file);

	// Make sure file opened and is a valid file.
	if(header[0] != 'p'	|| header[1] != 'a'	|| header[2] != 'l')
	{
		// File header not what was expected.
		//throw exception(); // NOT FOR DREAMCAST
		printf(">> ERROR: pallete header not what was expected!\n");
	}

	iMaxPalettes 		= header[3];	// Number of palettes in file.
	int iMaxEntries	= header[4];	// Number of entries per palette.
	int iPalette;							// palette index

	// Error if invalid # of palettes or # of entries.
	if (iMaxPalettes == 0 || iMaxEntries == 0) {
		//throw exception();
		printf(">> ERROR:  invalid # of palettes or palette entries.\n");
	}

	// Loop through each palette, storing it's values.
	for (iPalette = 0; iPalette < iMaxPalettes; iPalette++)
	{
		//printf("   >> palette #%i, %i entries.\n", iPalette+1, iMaxEntries);

		// Add another palette to the collection.
		vPalettes.push_back(cColorRGBPalette());

		// Loop through each entry in the palette, reading the red-green-blue
		// values from disk.
		for (int iEntry = 0; iEntry < iMaxEntries; iEntry++) {
			r = fgetc(file); g = fgetc(file); b = fgetc(file);
			t = LOAD_1555_NOALPHA(r,g,b);  // take r,g,b and output them in 2 bytes, no alpha
			vPalettes[iPalette] += t;
		}

	} // END palette loop

	pImageDataHolder = m_pImageData;	// Store original image data location.

	// cColorRGB	color;					
	unsigned short color;					// Used for pixel color manipulation.
	int			index;					// Entry position into palette.

	// Create a new image, one for each palette.
	// Start at 1 since palette at 0 is the source palette.
	for (iPalette = 1; iPalette < iMaxPalettes; iPalette++)
	{
		printf("Processing palette #%u\n", iPalette);

		// Allocate a new set of memory for the modified data.
		m_pImageData = (GLubyte*)pvr_mem_malloc(m_width * m_height * m_ByPP);

		// CAREFUL HOW MUCH m_ByPP is (should be OK)
		// Loop through each pixel in the image.
		for (	unsigned int iPixel = 0; iPixel < m_width * m_height; iPixel++)
		{
			// Set the components of the color to check for from the original
			// image data.
			color = pImageDataHolder[iPixel];	// 2 bytes

			// Look for this pixel's color in the source palette.
			if ((index = vPalettes[0].getEntryPosition(color)) != 0 )
			{
				// Color exists in palette...

				index--;	// Adjust index to real offset value.

				// XXX DREAMCAST
				// Set pixel to palette values.
				//m_pImageData[iPixel]	=	(vPalettes[iPalette])[index].r();
				//m_pImageData[iPixel+1] =(vPalettes[iPalette])[index].g();
				//m_pImageData[iPixel+2] =(vPalettes[iPalette])[index].b();
				
				// copy color to be replaced from palette into actual image
				// CAREFUL we want to preserve the alpha from the original image
				// and not use the alpha (always 0) from the palette
				
				// color from palette
				color = (vPalettes[iPalette])[index];

				// color from image
				t = m_pImageData[iPixel];

				// replace color from image with color from palette 
				// (t & 0x8000) is the alpha from src pixel
				m_pImageData[iPixel] = (color | (t & 0x8000));
			}
			else
			{
				// XXX DREAMCAST
				// XXX DONE
				// No match in palette so set pixel to old value.
				//m_pImageData[iPixel]	=		color.r();
				//m_pImageData[iPixel+1] =	color.g();
				//m_pImageData[iPixel+2] =	color.b();
				m_pImageData[iPixel] = color;
			}
		}

		createOpenGLTexture();	// Generate texture from image data.

		pvr_mem_free(m_pImageData);
	}
	
	// Set pointer back to memory location of original data.
	m_pImageData = pImageDataHolder;

	// close the file
	fclose(file);
	file = 0;

	// XXX no exception handling

	// Return one less than actual # because first palette is source palette.
	return iMaxPalettes - 1;
}
#endif

//////////////////////////////////////////////////////////////////////////////
//		XXX PUT THIS BACK UP TOP, MOVE FUNCTION TO BOTTOM
//	-	Reads in a palette file, and generates OpenGL textures from the 
//		existing image data.
//	-	The palette file contains a source palette which contains entries found 
//		in the image data.  It also contains one ore more other palettes which
//		are utilized to generate new image data by remapping colors.
//	-	Structure of a palette file:
//
//		Size	Name					Details
//		----	----------------	------------------------------------------------
//		3		Identifier			The letters "pal"
//		1		Palettes				p = Number of palettes in file.
//		1		Palette size		n = Number of color entries per palette.
//		3np	Palette(s)			Contains n*p # of RGB triplets.
//											(Note, the first palette is the source 
//											palette and the others are target palettes.)
//
//	-	EXAMPLE: 1. A source palette has 175,175,175 (light gray)
//					2. A target palette will have 255,0,0 (red) in the
//						corresponding field.
//					3. All light gray pixel will become red
//
//	ARGS:	filename,		Name of palette file to open.
//
//	PRE:	m_pImageData,	Populated with image data.
//
//	RETURNS:	# of OpenGL textures created (which is also the # of palettes)
//
//////////////////////////////////////////////////////////////////////////////

// from addons/libpng/kos_img.c - byteshift from 32 bits to 16 bits ARGB_1555
// except we ignore alpha.  this returns 2 bytes.
//
// this is used for comparison between colors in the palette and colors in the
// image itself.  we don't care about alpha for this.
// 
// original, with alpha
// #define LOAD1555(r, g, b, a) (((a>>7)<<15)|((r>>3)<<10)|((g>>3)<<5)|((b>>3)))
//
// new, ignores alpha (alpha = 0)

//////////////////////////////////////////////////////////////////////////////
//	CONSTRUCTOR
//////////////////////////////////////////////////////////////////////////////
cTextureImage::cTextureImage() :
	m_pImageData(NULL)
{
	filename1[0] = 0;
	clear();
}

//////////////////////////////////////////////////////////////////////////////
//	DESTRUCTOR
//////////////////////////////////////////////////////////////////////////////
cTextureImage::~cTextureImage()
{
	clear();
}

//////////////////////////////////////////////////////////////////////////////
//
// Clears contents of object.
//
//	POST:	-	Any allocated memory is freed.
//
//	XXX FIXME - THIS DOES NOT HAPPEN IN DC VERSION
//
//////////////////////////////////////////////////////////////////////////////
void cTextureImage::clear()
{
	// XXX DEBUG ONLY
	printf("starting clear()");
	if (filename1[0]) {
		printf("for %s", filename1);
	}
	printf("\n");
	
	// Free memory held by image data.
	if (m_pImageData != NULL)
	{
		pvr_mem_free(m_pImageData);
		m_pImageData = NULL;
	}
	
	printf("middle clear(), m_vID.size() = %u\n", m_vID.size());

	// Free OpenGL textures, and clear collection.
	if (m_vID.size() > 0)
	{
		for(unsigned int i=0; i < m_vID.size(); i++) // for each OpenGL texture.
			glDeleteTextures(1, &m_vID[i]);		// Delete the texture.

		m_vID.clear();									// Empty the collection.
	}

	m_width	= 0;
	m_height = 0;
	m_ByPP	= 0;
	printf("ending clear()\n");
}

// load a PCX file
// we need to replace 0xFF00FF with alpha mask
bool cTextureImage::loadPCX(const char *filename) {
	kos_img_t img;

	// read in the tha file to this class's m_img structure
	if (pcx_to_img(filename, &img)) {
  		printf(">> can't load %s\n", filename);
		return false;
	}

	// by default pcx files have no alpha
	// we use pink (normally) 0xFF00FF in the pcx file for transparency
	
	// this converts the image from RGB565 to ARGB1555
	// also swap RGB565 pink (0xF81F) to ARGB transparent (0x0000)
	unsigned short v;
	unsigned short *data = (unsigned short*)img.data;
	BYTE r,g,b;

	// loop through the pixels
	for (unsigned int i=0; i < img.w*img.h; i++) {

		v = data[i];
			
		// is it pink?
		if (v == 0xF81F) {
			data[i] = 0x0000;		// make it transparent
		} else {
			// original pixel RGB565
			r =  (v & 0xF800) >> 11;		// 5 bits
			g = ((v & 0x07E0) >> 5) >> 1; 	// 6 then 5 bits
			b =  (v & 0x001F);				// 5 bits
			// ARGB1555 (alpha = 1)
			data[i] = ( 0x8000 | (r<<10) | (g<<5) | (b) );
		}
	}
	
	// tell KOS the format changed
	img.fmt = KOS_IMG_FMT(KOS_IMG_FMT_ARGB1555, 0);
	
	m_width = img.w;
	m_height = img.h;
	m_ByPP = 2;			// hardcoded for now (thats BYTES PER PIXEL not BITS)

	// load raw texture data into memory
	m_pImageData = (GLubyte*)pvr_mem_malloc(m_width * m_height * m_ByPP);
	
	pvr_txr_load_kimg(&img, m_pImageData, PVR_TXRLOAD_INVERT_Y);
  
	// free the original PCX image data (not the texure, thats m_pImageData)
	kos_img_free(&img, 0);
	
	createOpenGLTexture();	// Generate texture from image data.
	
	return true;
}


//////////////////////////////////////////////////////////////////////////////
//
//	Creates an OpenGL texture from a blob of data.
//
//	PRE:	m_pImageData,	Points to data to create an OpenGL texture out of.
//
//////////////////////////////////////////////////////////////////////////////
void cTextureImage::createOpenGLTexture()
{
	GLuint txr;				// will be our texture ID

	// make the textures
  	glGenTextures(1, &txr);

	glBindTexture(GL_TEXTURE_2D, txr);
	m_vID.push_back(txr);	//	Store ID in collection.
	printf(">> txr#= %u\n", txr);
  
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_FILTER, GL_FILTER_NONE);
	
	glKosTex2D(GL_ARGB1555_TWID, m_width, m_height, m_pImageData);
	glTexEnvi(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATEALPHA);	
	
	// replaced for dreamcast verion with KOS stuff.
	// ORIGINAL OPENGL CODE GOES HERE
}
// vi:set ts=3:
