//////////////////////////////////////////////////////////////////////////////
//
// TextureImage.h
//	Defines for the cTextureImage class.
//
//////////////////////////////////////////////////////////////////////////////

// Turn off 4786: "identifier was truncated to '255' characters..."
#ifdef WIN32
#pragma warning(disable:4786)
#endif

#ifndef __TEXTUREIMAGE_H__
#define __TEXTUREIMAGE_H__

#include "inc/system.h"

#include "ColorRGB.h"			// Support for red-green-blue
#include "ColorRGBPalette.h"

class cTextureImage  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	GLuint	m_width;						// Image Width
	GLuint	m_height;					// Image Height
	GLubyte*	m_pImageData;				// Image data
	GLuint m_ByPP;						// Image color-depth in bytes per pixel.

	// XXX REMOVE THIS ONCE WORKING
	char filename1[256];

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	void clear();
	void createOpenGLTexture();					// Builds OpenGL textures.

public:
	cTextureImage();									// Constructor
	virtual ~cTextureImage();						// Destructor

	bool	loadPCX(const char *filename);		// Loads A TGA File Into Memory
	int	loadPalette(const char *filename);	// Reads in palette files.
	
	// XXX MOVE BACK TO PRIVATE
	vector<GLuint> m_vID;			// Collecting of texture ID's.
	
	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////
	/*inline*/ GLuint getWidth()			{ return m_width;	}	// Image width.
	/*inline*/ GLuint getHeight()			{ return m_height;}	// Image height.
	/*inline*/ GLuint getID(GLuint i=0)	{ return m_vID[i];}	// Texture ID.
};


#endif // __TEXTUREIMAGE_H__
// vi:set ts=3:
