// eventFactory.h: interface for the cEventFactory class.
//
// - Creates specific events based on event type
// - Tabs set to 3 spaces
//
//////////////////////////////////////////////////////////////////////

#ifndef __EVENTFACTORY_H__
#define __EVENTFACTORY_H__

#include "inc/system.h"

#include "screen.h"
#include "event.h"
#include "eventData.h"
#include "eventPortal.h"
#include "eventDialogue.h"
#include "gameState.h"

// Forward class definitions to avoid errors
//class cEvent;
//class cEventData;

class cEventFactory  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	cGameState* m_pGameState;	// Reference to current gamestate

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cEventFactory() {}			// Default constructor not used

public:
	cEventFactory( cGameState* pGameState );
	virtual ~cEventFactory();

	cEvent* create( cScreen* pScreen, cEventData& oEventData );
};

#endif // __EVENTFACTORY_H__
// vi:set ts=3:
