//////////////////////////////////////////////////////////////////////////////
//
// eventPortal.h
//	Defines of the cEventPortal class.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __EVENTPORTAL_H__
#define __EVENTPORTAL_H__

#include "event.h"      // Base class for all events.

// Forward declare to avoid circular references
class cEventData;
class cGameState;

class cEventPortal : public cEvent  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	int	m_iTargetMapID;	// ID of target map.
	int	m_iTargetScreenX;	// Target screen X position (screen coordinates).
	int	m_iTargetScreenY;	// Target screen Y position (screen coordinates).


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
private:
	cEventPortal(){}	// Default constructor non-creatable.

public:
	// Constructor
	cEventPortal( cGameState* pGameState, cScreen* pScreen, cEventData& oEventData );

	// Destructor
	virtual ~cEventPortal();

	// Trigger portal
	virtual void trigger();

	// Update event when necessary (not used with portals)
	virtual void update() {}

	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////
	// Retrieve the ID for the target map
	int getTargetMapID();

	// Retrieve the locations of the target screen
	int getTargetScreenX();
	int getTargetScreenY();	
};

#endif // __EVENTPORTAL_H__
// vi:set ts=3:
