//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTBoomerang.h
//	Defines for the cObjectBoomerang class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTBOOMERANG_H__
#define __OBJECTBOOMERANG_H__

#include <math.h>		// for vector math

#include "gameState.h"
#include "tiles.h"
#include "GameException.h"

#include "objectInventoryItem.h"
#include "inventory.h"
#include "objectLynk.h"

//////////////////////////////////////////////////////////////////////////////
//	CONSTANTS
//////////////////////////////////////////////////////////////////////////////

// State of boomerang as it flies.
enum eBOOMERANG_BEHAVIOR
{
	BOOMERANG_OUTGOING = 0,
	BOOMERANG_INCOMING,
	BOOMERANG_CAUGHT
};

enum eBOOMERANG_TYPE
{
	WOODEN_BOOMERANG = 0,
	MAGICAL_BOOMERANG
};


class cObjectBoomerang : public cObjectInventoryItem  
{
	///////////////////////////////////////////////////////////////////////////
	//  MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	eBOOMERANG_BEHAVIOR m_eCurrentBehavior;		// Boomerang "mental" state.


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:	
	cObjectBoomerang();	// Default constructor non-creatable.

	// Utility method used to find way back to link.
	void getVelocityVector(cSprite *oTarget, float fSpeed, float *fVector);


public:
	cObjectBoomerang(cGameState* pGameState);
	virtual ~cObjectBoomerang();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
	eHIT_TYPE getHitType() { return HIT_TYPE_BOOMERANG; }

	bool activate(float fx, float fy, eDIRECTION eDirection);

};

#endif // __OBJECTBOOMERANG_H__
// vi:set ts=3:
