//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTBow.h
//	Defines for the cObjectBow class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTBOW_H__
#define __OBJECTBOW_H__

#include "tiles.h"
#include "GameException.h"
#include "inventory.h"
//#include "gameState.h"

#include "objectInventoryItem.h"
#include "objectProjectileArrow.h"

 class cObjectBow : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileArrow* m_pProjectileArrow;

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectBow();	// Default constructor non-creatable.

public:
	cObjectBow(cGameState* pGameState);
	virtual ~cObjectBow();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
	bool activate(float fx, float fy, eDIRECTION eDirection);

	// Overload of reset to move wand while in swing.
	void reset(float fx, float fy);

	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////

	// If the rod is in motion.
	/*inline*/ bool isSwinging(){ return !isDead();	}
};

#endif // __OBJECTBOW_H__
// vi:set ts=3:
