//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTCandle.h
//	Defines for the cObjectCandle class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTCANDLE_H__
#define __OBJECTCANDLE_H__

#include "GameException.h"
#include "tiles.h"
#include "gameState.h"

#include "objectInventoryItem.h"
#include "objectProjectileFire.h"


class cObjectCandle : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileFire* m_pProjectileFire;


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectCandle();	// Default constructor non-creatable.

public:
	cObjectCandle(cGameState* pGameState);
	virtual ~cObjectCandle();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
	bool activate(float fx, float fy, eDIRECTION eDirection);

	// Overload of reset to move wand while in swing.
	void reset(float fx, float fy);

	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////

	// If the rod is in motion.
	/*inline*/ bool isSwinging(){ return !isDead();	}
};

#endif // __OBJECTCANDLE_H__
// vi:set ts=3:
