//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTInventoryItem.h
//	Defines for the cObjectInventoryItem class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTINVENTORYITEM_H__
#define __OBJECTINVENTORYITEM_H__

#include "inc/system.h"
#include "sprite.h"			// Support for sprites.
#include "gameState.h"		// Support for the game state object.

class cObjectInventoryItem : public cSprite  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	int m_iInventoryDisplayID; // which ID to use to display this item
								// in inventory
	long m_lSwingDelay;	// length of time in ms this item causes link to
						// be frozen in his attack pose

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectInventoryItem(){}	//	Default constructor non-creatable

public:
	cObjectInventoryItem(cGameState* pGameState, cSpriteData& oSpriteData);

	virtual void reset();

	virtual void reset(float fx, float fy);

	virtual ~cObjectInventoryItem();

	// Tell this item to activate itself
	virtual bool activate(float fx, float fy, eDIRECTION eDirection);

	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////
	/*inline*/ int getInventoryDisplayID() { return m_iInventoryDisplayID; }
	/*inline*/ BYTE getInventoryDisplayColor() { return m_yColorSetBeforeFlashing; }
	/*inline*/ long getSwingDelay() { return m_lSwingDelay; }
};

#endif // __OBJECTINVENTORYITEM_H__
// vi:set ts=3:
