//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTMagicalRod.h
//	Defines for the cObjectMagicalRod class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTMAGICALROD_H__
#define __OBJECTMAGICALROD_H__

#include "inc/system.h"

#include "sprite.h"
#include "tiles.h"
#include "GameException.h"

#include "objectInventoryItem.h"
#include "objectProjectileMagic.h"


class cObjectMagicalRod : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileMagic* m_pProjectileMagic;

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectMagicalRod();	// Default constructor non-creatable.

public:
	cObjectMagicalRod(cGameState* pGameState);
	virtual ~cObjectMagicalRod();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
	eHIT_TYPE getHitType() { return HIT_TYPE_SWORD; }
	
	bool activate(float fx, float fy, eDIRECTION eDirection);

	// Overload of reset to move wand while in swing.
	void reset(float fx, float fy);


	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////

	// If the rod is in motion.
	/*inline*/ bool isSwinging(){ return !isDead();	}
};

#endif // __OBJECTMAGICALROD_H__
// vi:set ts=3:
