//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTOctorock.h
//	Defines for the cObjectOctorock class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTOCTOROCK_H__
#define __OBJECTOCTOROCK_H__

#include "GameException.h"
#include "tiles.h"
#include "sprite.h"			// Support for sprites.
#include "gameState.h"		// Support for the game state object.

class cObjectOctorock : public cSprite  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	bool	m_bMoving;		// If sprite is currently moving.
	float	m_fMoveTime;	// How long to keep moving.


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectOctorock(){}	//	Default constructor non-creatable

public:
	cObjectOctorock(cGameState* pGameState, cSpriteData& oSpriteData);
	virtual ~cObjectOctorock();

	// Implementation of cSprite virtuals...	
	bool collide(cSprite* pSprite);
	void moveBack();
	void hit(cSprite* pSprite);
	void reset();
	void update();
	void draw();	

};

#endif //  __OBJECTOCTOROCK_H__

// vi:set ts=3:
