/////////////////////////////////////////////////////////////////////////////
//
//	OBJECTprojectileArrow.h
//	Defines for the cObjectProjectileArrow class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTPROJECTILEARROW_H__
#define __OBJECTPROJECTILEARROW_H__

#include "GameException.h"
#include "tiles.h"
#include "gameState.h"
#include "objectInventoryItem.h"

class cObjectProjectileArrow : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileArrow();	// Default constructor non-creatable.

public:
	cObjectProjectileArrow(cGameState* pGameState);
	virtual ~cObjectProjectileArrow();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();

	eHIT_TYPE getHitType() { return HIT_TYPE_ARROW; }
	

	// Start a swinging of the projectile.
	bool activate(float fx, float fy, eDIRECTION eDirection);

	// Overload of reset to move projectile while in swing.
	void reset(float fx, float fy);

};

#endif // __OBJECTPROJECTILEARROW_H__
// vi:set ts=3:
