//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTprojectileFIRE.h
//	Defines for the cObjectProjectileFIRE class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTPROJECTILEFIRE_H__
#define __OBJECTPROJECTILEFIRE_H__

#include "gameState.h"
#include "objectInventoryItem.h"
#include "tiles.h"
#include "GameException.h"

class cObjectProjectileFire : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	long m_lMoveTime;

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileFire();	// Default constructor non-creatable.

public:
	cObjectProjectileFire(cGameState* pGameState);
	virtual ~cObjectProjectileFire();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();

	eHIT_TYPE getHitType() { return HIT_TYPE_MAGIC; }

	// Start a swinging of the projectile.
	bool activate(float fx, float fy, eDIRECTION eDirection);

	// Overload of reset to move projectile while in swing.
	void reset(float fx, float fy);

};

#endif // __OBJECTPROJECTILEFIRE_H__
// vi:set ts=3:
