//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTStillSword.h
//	Defines for the cObjectStillSword class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTSTILLSWORD_H__
#define __OBJECTSTILLSWORD_H__

#include "GameException.h"
#include "tiles.h"
#include "gameState.h"
#include "inventory.h"
#include "objectLynk.h"
#include "objectInventoryItem.h"
#include "objectProjectileSword.h"

class cObjectStillSword : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileSword* m_pProjectileSword;

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectStillSword();	// Default constructor non-creatable.

public:
	cObjectStillSword(cGameState* pGameState);
	virtual ~cObjectStillSword();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();

	eHIT_TYPE getHitType() { return HIT_TYPE_SWORD; }

	// Overload of reset to move sword while in swing.
	void reset(float fx, float fy);

	// Start a swinging of the sword.
	bool activate(float fx, float fy, eDIRECTION eDirection);
};

#endif // __OBJECTSTILLSWORD_H__
// vi:set ts=3:
