// screenTemplate.h: interface for the cScreenTemplate class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __SCREENTEMPLATE_H__
#define __SCREENTEMPLATE_H__

#include "inc/system.h"

#include "sprite.h"
#include "spriteData.h"
#include "gameState.h"

class cScreenTemplate  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
private:	
	BYTE	m_ySize;		// Number of sprites in the template

	// Data for Sprites in the template
	vector<cSpriteData*>	m_vpSpriteData;

	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cScreenTemplate(){}		// Default constructor non-creatable.

	///////////////////////////////////////////////////////////////////////////
	//	ACCESSORS
	///////////////////////////////////////////////////////////////////////////
public:
	cScreenTemplate(cGameState* pGameState, FILE* pFileHandle);	// Constructor
	virtual ~cScreenTemplate();											// Destructor

	// Obtains a copy of the sprites used in the template.
	/*inline*/ vector<cSpriteData*> getAllSpriteData();

	// Obtains a pointer to a specific sprite in the template
	/*inline*/ cSpriteData* getSpriteData( int iID );

	// Obtains the number of sprites in the template
	/*inline*/ int getSize();
};

// STL iterator for looping through collection of screen templates.
typedef vector<cScreenTemplate*>::iterator TEMPLATE_ITR;

#endif // __SCREENTEMPLATE_H__
// vi:set ts=3:
