//////////////////////////////////////////////////////////////////////////////
//
// spriteFactory.h
//	Defines for the cSpriteFactory class.
//
//	-	Creates specific sprite classes based on sprite object information.
//	-	Tabs set to 3 spaces.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __SPRITEFACTORY_H__
#define __SPRITEFACTORY_H__

#include "gameState.h"
#include "GameException.h"
#include "sprite.h"			// Support for sprites.
#include "spriteData.h"		// Support for reading sprites from disk.
#include "objectOctorock.h"
#include "spriteScreenTile.h"

class cSpriteFactory  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	cGameState* m_pGameState;	// The game state.


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cSpriteFactory(){} 	// Default constructor non-creatable.

public:
	cSpriteFactory(cGameState* pGameState);
	virtual ~cSpriteFactory();

	cSprite* create(cSpriteData& oSpriteData);
};

#endif // __SPRITEFACTORY_H__
// vi:set ts=3:
