//////////////////////////////////////////////////////////////////////////////
//
//	spriteMapTile.h
//	Defines for the cSpriteMapTile class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __SPRITEMAPTILE_H__
#define __SPRITEMAPTILE_H__

#include "gameState.h"
#include "GameException.h"
#include "tiles.h"
#include "sprite.h"			// Support for sprites.
#include "spriteData.h"		// Support for reading sprites from disk.

class cSpriteScreenTile : public cSprite  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMEBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	long m_ID;			// The ID of the tile to draw.

	cGameState* m_pGameState;


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cSpriteScreenTile(){}	// Default constructor non-creatable.

public:
	// Constructor
	cSpriteScreenTile(cGameState* pGameState, cSpriteData& oSpriteData);

	// Destructor
	virtual ~cSpriteScreenTile();

	// Implementation of cSprite virtuals...	
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
};

#endif // __SPRITEMAPTILE_H__
// vi:set ts=3:
