//////////////////////////////////////////////////////////////////////////////
//
//	Window.h
//	Defines for the cWindow class.
//
//	-	Based on Jeff Molofee's OpenGL basecode (http://nehe.gamedev.net)
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __WINDOW__H__
#define __WINDOW__H__

#include "inc/system.h"

// Some compilers do not define this value, so provide an explicity define.
//#ifndef CDS_FULLSCREEN			
//#define CDS_FULLSCREEN 4
//#endif // CDS_FULLSCREEN

// User define for toggling between windowed and full screen.
//#define WM_TOGGLEFULLSCREEN (WM_USER+1)

const int KEYBOARD_MAP_SIZE = 0xFFFF;	// Keyboard "key map" size
//static bool g_isProgramLooping;		// Window Creation Loop
//static bool g_createFullScreen;		// If TRUE, create fullscreen window

class cWindow  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
protected:
	int			m_iWidth;				// Window width.
	int			m_iHeight;				// Window height.
	int			m_iBitsPerPixel;		// Bits per pixel.

public:
	char*			m_szTitle;							// Window title.
	bool			m_bIsVisible;						// Window visible?
	bool			m_bIsFullScreen;					// FullScreen mode?
	bool	m_key[KEYBOARD_MAP_SIZE];	// Holds bool for each keyboard key.


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
public:
	cWindow();
	virtual ~cWindow();

	void terminateApplication();
	void toggleFullscreen();
	void reshapeGL(int iWidth, int iHeight);
	bool changeScreenResolution(int iWidth, int iHeight, int iBitsPerPixel);
	bool createWindowGL();
	void destroyWindowGL();
	
	inline int getWidth() {return m_iWidth;};
	inline int getHeight() {return m_iHeight;};
};


#endif // __WINDOW__H__
// vi:set ts=3:
